"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

const path_1 = require("path");

const fs_extra_1 = require("fs-extra");

function isDirectoryAndExist(path) {
  return (0, fs_extra_1.existsSync)(path) && (0, fs_extra_1.statSync)(path).isDirectory();
}

function getServicePaths({
  cwd,
  env
}) {
  let absSrcPath = cwd;

  if (isDirectoryAndExist((0, path_1.join)(cwd, 'src'))) {
    absSrcPath = (0, path_1.join)(cwd, 'src');
  }

  const tmpDir = ['.vite-plugin-react-auto-config', env !== 'development' && env].filter(Boolean).join('-');
  return {
    cwd,
    absNodeModulesPath: (0, path_1.join)(cwd, 'node_modules'),
    absSrcPath: (0, path_1.join)(cwd, 'src'),
    absTmpPath: (0, path_1.join)(absSrcPath, tmpDir)
  };
}

exports.default = getServicePaths;